using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace NestedTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.grid)).BeginInit();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.grid.BackColor = System.Drawing.SystemColors.Window;
			this.grid.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.grid.ChildGroupOptions.ShowFilterBar = true;
			this.grid.Location = new System.Drawing.Point(0, 3);
			this.grid.Name = "grid";
			this.grid.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.grid.Size = new System.Drawing.Size(546, 521);
			this.grid.TabIndex = 1;
			this.grid.TableDescriptor.Appearance.AnyCell.ReadOnly = false;
			this.grid.TableDescriptor.Appearance.FilterBarCell.Enabled = true;
			this.grid.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.grid.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.None;
			this.grid.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.grid.Text = "gridGroupingControl1";
			this.grid.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.grid.TopLevelGroupOptions.ShowFilterBar = false;
			this.grid.TopLevelGroupOptions.ShowGroupPreview = false;
			this.grid.VersionInfo = "4.202.0.37";
			this.grid.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.grid_TableControlCellClick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(546, 526);
			this.Controls.Add(this.grid);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.grid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int numberParentRows = 100;
		private GridGroupingControl grid;
		private int numberChildRows = 100;

		# region DataTables

		private DataTable GetTable1()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			dt.Columns.Add(new DataColumn("check", typeof(bool)));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetTable2()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); 
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); 
			dt.Columns.Add(new DataColumn("dropCol1"));
			dt.Columns.Add(new DataColumn("dropCol2"));
			dt.Columns.Add(new DataColumn("dropCol3"));
			dt.Columns.Add(new DataColumn("dropCol4"));
			dt.Columns.Add(new DataColumn("dropCol5"));
			dt.Columns.Add(new DataColumn("dropCol6")); 

			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = (i % numberParentRows + 300).ToString();
				dr[4] = (i % numberParentRows + 400).ToString();
				dr[5] = (i % numberParentRows + 500).ToString();
				dr[6] = (i % numberParentRows + 600).ToString();
				dr[7] = (i % numberParentRows + 700).ToString();
				dr[8] = (i % numberParentRows + 800).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		#endregion

		DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetTable1();
			DataTable childTable = GetTable2();

			ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});
			grid.DataSource = ds;


			CollapseAll(grid.Table);


		}

		/// <summary>
		/// Recursive collapse function
		/// </summary>
		/// <param name="table">current recursion level</param>
		private void CollapseAll(GridTable table)
		{
			table.CollapseAllGroups();
			foreach (GridTable relatedTable in table.RelatedTables)
			{
				CollapseAll(relatedTable);
			}
		}

		private void grid_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
		{
			e.TableControl.CurrentCell.MoveTo(e.Inner.RowIndex, e.Inner.ColIndex, GridSetCurrentCellOptions.SetFocus); 
		}	

	}
}
